import { TransformerPluginBase } from '@aws-amplify/graphql-transformer-core';
import { TransformerAuthProvider, TransformerContextProvider, TransformerPrepareStepContextProvider, TransformerSchemaVisitStepContextProvider, TransformerTransformSchemaStepContextProvider, TransformerValidationStepContextProvider, TransformerPreProcessContextProvider } from '@aws-amplify/graphql-transformer-interfaces';
import { DirectiveNode, DocumentNode, FieldDefinitionNode, InterfaceTypeDefinitionNode, ObjectTypeDefinitionNode } from 'graphql';
import { ModelTransformer } from '@aws-amplify/graphql-model-transformer';
import { IndexTransformer } from '@aws-amplify/graphql-index-transformer';
import { HasOneTransformer } from './graphql-has-one-transformer';
export declare class ManyToManyTransformer extends TransformerPluginBase {
    private relationMap;
    private directiveList;
    private modelTransformer;
    private indexTransformer;
    private hasOneTransformer;
    private authProvider;
    constructor(modelTransformer: ModelTransformer, indexTransformer: IndexTransformer, hasOneTransformer: HasOneTransformer, authProvider: TransformerAuthProvider);
    field: (parent: ObjectTypeDefinitionNode | InterfaceTypeDefinitionNode, definition: FieldDefinitionNode, directive: DirectiveNode, context: TransformerSchemaVisitStepContextProvider) => void;
    mutateSchema: (context: TransformerPreProcessContextProvider) => DocumentNode;
    validate: (ctx: TransformerValidationStepContextProvider) => void;
    prepare: (ctx: TransformerPrepareStepContextProvider) => void;
    transformSchema: (ctx: TransformerTransformSchemaStepContextProvider) => void;
    generateResolvers: (ctx: TransformerContextProvider) => void;
}
//# sourceMappingURL=graphql-many-to-many-transformer.d.ts.map